EntityRender = class('Entity', nil)
EntityRender.instances = {}

function EntityRender.renderInstances()
    for i, instance in ipairs(EntityRender.instances) do
        instance:render()
    end
end

function EntityRender.sortRenderersByZ()
    table.sort( EntityRender.instances, function(a,b) return a.z < b.z end)
end

function EntityRender:initialize(z)
    self.z = z or 0
    table.insert( EntityRender.instances, self )
    EntityRender.sortRenderersByZ()
end

function EntityRender:destroy()
    for i, v in ipairs(EntityRender.instances) do
        if v == self then
            table.remove( EntityRender.instances, v )
            break
        end
    end
end

function EntityRender:setZ(z)
    self.z = z
    EntityRender.sortRenderersByZ()
end

function EntityRender:render()
    -- stub function
end