require 'InputController'

PortInputController = class('PortInputController', InputController)

local AWAITING_FORWARD_PORT_SELECTION = 1

function PortInputController:initialize( portController )
    InputController.initialize(self)
    self.portController = portController
    NotificationController.listen( "on_key_pressed", self, self.onKeyPressed, self )
end

function PortInputController:update( dt )
    if GridController.instance:getSystemUnderMouse() == self.portController.systemController then
        local p = getCurrentCamera():localMouseCoords( self.portController.systemController.position )
        local boundingBox = self.portController:getBoundingBox()
        self:updateMouseDownState( p, boundingBox, 'l', 'm', 'r' )
    else
        self.mouseOverState = MOUSE_OFF
    end
end

function PortInputController:onEnterMouseDown( )
    if not self.portController.backdoor and not self.button and self.state == nil and love.mouse.isDown( 'l' ) then
        local x, y = love.mouse.getPosition()
        self.button = loveframes.Create( "button" )
        self.button:SetSize( 200, 25 )
        self.button:SetPos( x, y - 35 )
        
        if self.portController:isForwarded() then
            self.button:SetText( "Remove Port Forward" )
            self.button.OnClick = function(object)
                self.portController:removeForwardPort()
                object:Remove()
                self.button = nil
            end
        else
            self.button:SetText( "Port Forward" )
            self.button.OnClick = function(object)
                self.state = AWAITING_FORWARD_PORT_SELECTION
                object:Remove()
                self.button = nil
            end
        end
        
    end
end

function PortInputController:onKeyPressed( key, unicode )
    if key == 'f' and self:getMouseOverState() == MOUSE_OVER then
        self.state = AWAITING_FORWARD_PORT_SELECTION
    end
end

function PortInputController:onMouseButtonPressed( mx, my, button )
    if self.button and not self.button:GetHover() then
        self.button:Remove()
        self.button = nil
    end
    
    if self.state == AWAITING_FORWARD_PORT_SELECTION then
        if button == 'r' then
            local portUnderMouse = self:getEntityUnderMouse( PortController )
            if portUnderMouse then
                self.portController:sendMessage( MSG_PORT_FORWARD, portUnderMouse )
            end
        end
        self.state = nil
    end
end

function PortInputController:isAwaitingForwardPortSelection()
    return self.state == AWAITING_FORWARD_PORT_SELECTION
end