ProgramRenderer = class('ProgramRenderer', EntityRender)
ProgramRenderer:include( Stateful )
ProgramRenderer.STATE_INSIDE_PORT = ProgramRenderer:addState('INSIDE_PORT')
 
function ProgramRenderer:initialize( )
    --EntityRender.initialize(self)
end

function ProgramRenderer:setProgramController( programController )
    self.programController = programController
end

function ProgramRenderer:programEnteredState( stateName )
    if stateName == 'INSIDE_PORT' then
        self:gotoState( 'INSIDE_PORT' )
    end
end

function ProgramRenderer:programExitedState( stateName )
    if stateName == 'INSIDE_PORT' then
        self:gotoState()
    end
end

function ProgramRenderer:render()
    local localPosition  = self.programController.position
    local systemPosition = self.programController.systemController.position 
    local bounds = self.programController:getBoundingBox()

    if self.programController:getSelected() then
        love.graphics.setColor(0,255,0)
    else
        love.graphics.setColor(19,50,120)
    end
    love.graphics.rectangle( "fill", bounds.x1, bounds.y1, bounds.width, bounds.height )
    
    return true
end

function ProgramRenderer.STATE_INSIDE_PORT:render()
    -- render nothing.
end