-- Filename: 
-- Author: Luke Perkin
-- Date: 2012-05-05

require "libs"
require "lovelibs"
require "lovelibs.loveframes.init"

require "StateMainMenu"
require "StateGame"
require "tests"

RESOURCE_PATH   = "resources/"
IMAGES_PATH     = RESOURCE_PATH .. "images/"
FONTS_PATH      = RESOURCE_PATH .. "fonts/"

-- Initialization
function love.load( args )
    love.graphics.setLineStyle( 'smooth' )
    Gamestate.registerEvents()
    
    if args[2] == "server" then
        Gamestate.switch( StateGame, true )
    elseif args[2] == "client" then
        Gamestate.switch( StateGame, false, "127.0.0.1", "Client" )
    else
        Gamestate.switch( StateMainMenu )
    end
end

-- Logic
function love.update(dt)
	loveframes.update( dt )
end

-- Rendering
function love.draw()
	
end

-- Input
function love.keypressed( key, unicode )
	loveframes.keypressed(key,unicode)
end

function love.keyreleased( key, unicode )
	loveframes.keyreleased(key,unicode)
end

function love.mousepressed( x, y, button )
    loveframes.mousepressed(x,y,button)
end

function love.mousereleased( x, y, button )
    loveframes.mousereleased(x,y,button)
end
